import java.util.Calendar;
import java.util.Vector;

public class Arbol {
	public void fijarArbol(String idMateria,String idClase) {
		if (this.idMateria!=idMateria || this.idClase!=idClase) this.actualizarArbol(idMateria, idClase);
	}
	private String idMateria = null;
	private String idClase = null;
	private Vector<String> ids = new Vector<String>();
	private Vector<String> nodos= new Vector<String>();
	private Vector<Integer> duraciones= new Vector<Integer>();
	private Vector<Integer> niveles= new Vector<Integer>();
	private Vector<String> padres= new Vector<String>();
	public void borrarTodo(){ids.removeAllElements();nodos.removeAllElements();duraciones.removeAllElements();niveles.removeAllElements();padres.removeAllElements();}
	public boolean esPadre(Integer indice) {return padres.indexOf(ids.get(indice))>=0;}
	private boolean tieneHijos(Integer indice) { return (padres.indexOf(ids.get(indice))>=0);}
	public Vector<String> hijos(Integer indice) {
		Vector<String> resultado = new Vector<String>(); 
		for (int i=0;i<ids.size();i++)
			if (padres.get(i).equals(ids.get(indice))) resultado.add(ids.get(i));
		return resultado;
	}
	public boolean estaIdNodo(String idNodo) {return (ids.indexOf(idNodo)>=0);}
	/*public boolean estanIdNodos(Vector<String> idNodos) {
		boolean estan  = true;
		for (int i=0;i<idNodos.size() && estan == true;i++)
			if (this.ids.indexOf(idNodos.get(i))<0) estan=false;
		return estan;
		}*/
	public String idNodoParaMinutosRequeridos(int minutos){
		String idNodo=null;
		int mi=minutos;
		for (int i=0;i<this.nodos.size();i++)
			if (!this.tieneHijos(i)) {
				Integer duracion=this.duraciones.get(i);
				if (duracion==null) duracion=0;
				if (mi<duracion) {
					idNodo=this.ids.get(i);
					break;
				} else mi-=duracion;
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+minutos+") "+((idNodo!=null)?this.nodos.get(ids.indexOf(idNodo)):"null"));
		return idNodo;
	}
	public int minutosDisponiblesParaParcial(Integer parcial){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+parcial+")");
		Integer minutos=0;
		if (parcial!=null && Parcial.numeroParciales()>0){
			Vector<Vector<String>> uhorarias = PCuaderno.MiPCuaderno.bbdd.consultarUHMateriaClase(MateriaClase.getIdMateriaClase(this.idMateria,this.idClase));
			Vector<Integer> duracionDia = null; 
			if (uhorarias!=null) if (uhorarias.size()>0) {
				//System.out.println("MateriaClase fechaDuracionMateriaClase ("+minutos+","+idMateria+","+idClase+") uhs = "+uhorarias.size());
				duracionDia = new Vector<Integer>();
				for (int i=0;i<Fecha.NDiasSemana;i++) duracionDia.add(0);
				for (int i=0;i<uhorarias.size();i++) {
					Calendar fi = Fecha.hora(uhorarias.get(i).get(2), uhorarias.get(i).get(3));
					Calendar ff = Fecha.hora(uhorarias.get(i).get(4), uhorarias.get(i).get(5));
					int tmp=duracionDia.get(Integer.valueOf(uhorarias.get(i).get(1)));
					tmp=tmp+(int)(ff.getTimeInMillis()-fi.getTimeInMillis())/(60 * 1000);
					//System.out.println("MateriaClase duracionMateriaClase ff = "+ff.getTimeInMillis()+" fi = "+fi.getTimeInMillis());
					duracionDia.set(Integer.valueOf(uhorarias.get(i).get(1)), tmp);
				}
			}
			uhorarias = null;
			if (duracionDia!=null) if (duracionDia.size()>0) {
				Calendar fecha=Fecha.fechaHoraCero(Parcial.getFechaInicioParcial(parcial));
				Calendar fechaLimite=Parcial.getFechaFinParcial(parcial);
				fechaLimite.add(Calendar.DAY_OF_MONTH, 1);
				fechaLimite=Fecha.fechaHoraCero(fechaLimite);
				while (fecha.compareTo(fechaLimite)<0){
					if (Fecha.diaLaboral(fecha,true))
						minutos+=duracionDia.get(fecha.get(Calendar.DAY_OF_WEEK));
					//System.out.println(" fecha "+Fecha.formaFechaDiaHora(fecha)+"<"+Fecha.formaFechaDiaHora(fechaLimite)+" minutos "+minutos);
					fecha.add(Calendar.DAY_OF_MONTH, 1);
				}
			}
			
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+parcial+")");
		return minutos;
	}
	public Vector<String> idNodosParcial(Integer parcial){
		Integer desde=0;
		Vector<String> idNodos = new Vector<String>(); 
		for (int i=1;i<=parcial-1;i++) desde+=this.minutosDisponiblesParaParcial(i);
		Integer hasta=desde+this.minutosDisponiblesParaParcial(parcial);
		int mi=0;
		for (int i=0;i<this.ids.size();i++) {
			Integer duracion=duraciones.get(i);
			if (duracion==null) duracion=0;
			if (mi >= desde) idNodos.add(this.ids.get(i));
			if ((mi + duracion) >= hasta) break;
			if (!esPadre(i)) mi+=duracion;
		}
		return idNodos;
	}
	public Vector<Vector<String>> enunciadosNodos(Vector<String> idNodos){
		Vector<Vector<String>> tabla = new Vector<Vector<String>>();
		if (idNodos!=null) if (idNodos.size()>0)
			for (int i=0;i<idNodos.size();i++){
				String sangria="";
				for (int j=0;j<niveles.get(ids.indexOf(idNodos.get(i)));j++) sangria=sangria+" ";
				Vector<String> registro = new Vector<String>(); 
				registro.add(idNodos.get(i));
				registro.add(sangria+nodos.get(ids.indexOf(idNodos.get(i))));
				tabla.add(registro);
			}
		return tabla;
	}
	public void actualizarArbol(String idMateria,String idClase) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+")");
		this.borrarTodo();
		actualizarNodo(0,null,idMateria,idClase);
		this.idMateria=idMateria;
		this.idClase=idClase;
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+") end");
	}
	private void actualizarNodo(Integer nivel,String idNodo,String idMateria,String idClase) {
		Vector<Vector<String>> nodosHijo = PCuaderno.MiPCuaderno.bbdd.consultarProgramacionNodoHijos(idNodo,idMateria);
		if (nodosHijo!=null){
			if (nodosHijo.size() > 0) {
				for (int i = 0; i < nodosHijo.size(); i++) {
					this.ids.add(nodosHijo.get(i).get(0));
					this.nodos.add(nodosHijo.get(i).get(4));
					this.padres.add(idNodo);
					this.duraciones.add(0);
					this.niveles.add(nivel);
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar(nodosHijo.get(i).get(2) + ": ("
							+ nodosHijo.get(i).get(0) + ") "
							+ nodosHijo.get(i).get(4));
					actualizarNodo(nivel+1,nodosHijo.get(i).get(0),idMateria,idClase);
				}
			} else {
				if (idClase!=null) {
					Vector<Vector<String>> nodoInfo = 
							PCuaderno.MiPCuaderno.bbdd.consultarProgramacionDuracionNodo(idNodo,idClase);
					if (nodoInfo!=null) if (nodoInfo.size() > 0)
						duraciones.set(ids.indexOf(idNodo),	Integer.valueOf(nodoInfo.get(0).get(2)));
				}
			}
		}
	}

}
