/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

public class Calendario extends Composite {
	private Vector<Label> etiquetas = new Vector<Label>();
	private Vector<Integer> fechas = new Vector<Integer>();
	private Vector<String> idsEvento = new Vector<String>();
	private Calendar fechaHoyCalendario = null;
	private Calendar fechaTrabajoCalendario = null;
	private Calendar fInicioParcial = null;
	private Calendar fFinParcial = null;
	public Calendario(Composite parent, int style) {super(parent, style);initialize();}
	
	public void actualizar(){
		actualizarDiasNoLectivosClase();
		actualizarEtiquetaDiaHoyParcial();
	}
	private void initialize() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		GridLayout gridLayoutCalendario = new GridLayout();
		gridLayoutCalendario.horizontalSpacing = 2;
		gridLayoutCalendario.verticalSpacing = 2;
		gridLayoutCalendario.marginWidth = 2;
		gridLayoutCalendario.marginHeight = 2;
		gridLayoutCalendario.numColumns = Fecha.MesesPorFilaCalendario;
		GridData gridDataCalendario = new GridData();
		gridDataCalendario.grabExcessHorizontalSpace = true;
		gridDataCalendario.grabExcessVerticalSpace = true;
		gridDataCalendario.horizontalAlignment = GridData.FILL;
		gridDataCalendario.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataCalendario);
		this.setLayout(gridLayoutCalendario);
		this.setSize(new Point(685, 340));
		Calendar fecha = (Calendar)Fecha.inicioCurso.clone();
		Label labelPrueba = new Label(this, SWT.NONE);
    	FontData[] fD = labelPrueba.getFont().getFontData();
    	fD[0].setStyle(SWT.BOLD);
    	Font fuente = new Font(PCuaderno.MiPCuaderno.display,fD[0]);
    	labelPrueba.dispose();
    	labelPrueba = null;
		for (int i=0;i<Fecha.MesesLectivosCurso;i++) {
			GridData gridDataCalendarioMes = new GridData();
			gridDataCalendarioMes.grabExcessHorizontalSpace = true;
			gridDataCalendarioMes.grabExcessVerticalSpace = true;
			gridDataCalendarioMes.horizontalAlignment = GridData.FILL;
			gridDataCalendarioMes.verticalAlignment = GridData.FILL;
			GridLayout gridLayoutCalendarioMes = new GridLayout();
			gridLayoutCalendarioMes.numColumns = Fecha.NDiasSemana;
			gridLayoutCalendarioMes.horizontalSpacing = 1;
			gridLayoutCalendarioMes.verticalSpacing = 1;
			gridLayoutCalendarioMes.marginWidth = 0;
			gridLayoutCalendarioMes.marginHeight = 0;
			Composite compositeCalendarioMes = new Composite(this, SWT.BORDER);
			compositeCalendarioMes.setLayout(gridLayoutCalendarioMes);
			compositeCalendarioMes.setLayoutData(gridDataCalendarioMes);
			compositeCalendarioMes.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			Label labelCalendarioMes = new Label(compositeCalendarioMes, SWT.CENTER | SWT.SHADOW_OUT);
	        GridData gridDataLabelCalendarioMes = new GridData(GridData.FILL_HORIZONTAL);
	        gridDataLabelCalendarioMes.horizontalSpan = Fecha.NDiasSemana;
	        labelCalendarioMes.setLayoutData(gridDataLabelCalendarioMes);
	        labelCalendarioMes.setText(Fecha.mesLargo(fecha)+" "+fecha.get(Calendar.YEAR));
			labelCalendarioMes.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			labelCalendarioMes.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	        boolean preRelleno=true,postRelleno=false;
	        //System.out.println("Calendario initialize fecha:"+fecha.get(Calendar.DAY_OF_MONTH)+"/"+fecha.get(Calendar.MONTH)+"/"+fecha.get(Calendar.YEAR));
	        for (int j=0;j<42;j++){
				GridData gridDataLabelDiaCalendario = new GridData();
				gridDataLabelDiaCalendario.grabExcessHorizontalSpace = true;
				gridDataLabelDiaCalendario.grabExcessVerticalSpace = true;
				gridDataLabelDiaCalendario.horizontalAlignment = GridData.FILL;
				gridDataLabelDiaCalendario.verticalAlignment = GridData.FILL;
	        	Label labelDiaCalendario = new Label(compositeCalendarioMes, SWT.CENTER);
	        	labelDiaCalendario.setLayoutData(gridDataLabelDiaCalendario);
	        	labelDiaCalendario.setFont( fuente );
	        	int columnaEtiqueta=(j%Fecha.NDiasSemana);
	        	int diaSemanaEtiqueta=((columnaEtiqueta+Fecha.PrimerDiaSemanaLaboral<=Fecha.NDiasSemana)?columnaEtiqueta+Fecha.PrimerDiaSemanaLaboral:columnaEtiqueta-(Fecha.NDiasSemana - Fecha.PrimerDiaSemanaLaboral));
	        	//System.out.println("Calendario initialize  columna = "+columnaEtiqueta+", 1erDiaSemanaLaboral = "+Fecha.PrimerDiaSemanaLaboral+", DiasSemana = "+Fecha.DiasSemana+", diaSemanaEtiqueta = "+diaSemanaEtiqueta);
	        	if (preRelleno && (fecha.get(Calendar.DAY_OF_WEEK)==diaSemanaEtiqueta)) preRelleno=false;
        		//System.out.println("Calendario initialize  dia "+fecha.get(Calendar.DAY_OF_MONTH)+"/"+fecha.get(Calendar.MONTH)+"/"+fecha.get(Calendar.YEAR)+" ["+preRelleno+","+postRelleno+"]: ("+fecha.get(Calendar.DAY_OF_WEEK)+","+primerDiaSemana+") "+((fecha.get(Calendar.DAY_OF_WEEK)>=primerDiaSemana)?fecha.get(Calendar.DAY_OF_WEEK)-primerDiaSemana:fecha.get(Calendar.DAY_OF_WEEK)+(7-primerDiaSemana))+"=="+(j%7)+". dias maximo mes = "+fecha.getMaximum(Calendar.DAY_OF_MONTH));
	        	if (preRelleno || postRelleno) {
	        		labelDiaCalendario.setText("");
	        		//if (Fecha.diaSemanaFestivo(diaSemanaEtiqueta)) {
	        		//	labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	        		//} else {
	    				labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	        		//}
	        	} else {
	        		labelDiaCalendario.setText(Integer.toString(fecha.get(Calendar.DAY_OF_MONTH)));
	        		etiquetas.add(labelDiaCalendario);
	        		fechas.add(Fecha.formaFechaInt(fecha));
	        		idsEvento.add("");
	        		if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
	    				labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	        			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	        		} else {
	        			labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	        			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	        		}
	        		final String idEvento=String.valueOf(etiquetas.size()-1);
	        		labelDiaCalendario.addMouseListener(new org.eclipse.swt.events.MouseAdapter() {
						public void mouseUp(org.eclipse.swt.events.MouseEvent e) {
							if (!idsEvento.get(Integer.parseInt(idEvento)).equals("")) {
								//System.out.println("Calendario initialize Visualizando evento: "+idsEvento.get(Integer.parseInt(idEvento)));
								PCuaderno.MiPCuaderno.seleccionarFicha(PCuaderno.MiPCuaderno.tituloEventos);
								PCuaderno.MiPCuaderno.evento.seleccionarEvento(idsEvento.get(Integer.parseInt(idEvento)));
							}
						}
					});
	        		//System.out.println("Calendario initialize etiquetaDia "+ Fecha.formaFechaDia(fecha));
        			fecha.add(Calendar.DAY_OF_MONTH, 1);
	        		if (fecha.get(Calendar.DAY_OF_MONTH)==1){ postRelleno=true;}
	        	}
	        }
		}
		ponerDiasNoLectivos();
		ponerEventosCalendario();
		actualizarEtiquetaDiaHoyParcial();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("end",true);
	}
	public void actualizarCalendario(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Calendar fecha = (Calendar)Fecha.inicioCurso.clone();
		int parcialTrabajo=Parcial.getParcial(Fecha.fechaDeTrabajo);
		for (;fecha.compareTo(Fecha.finCurso)<=0;fecha.add(Calendar.DAY_OF_MONTH, 1)) {
			fecha=Fecha.fechaHoraCero(fecha);
			int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
			if (indice>=0) {
				Label labelDiaCalendario = etiquetas.get(indice);
				idsEvento.set(indice, "");
	    		if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
					labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	    			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	    		} else {
					labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	    			if (Parcial.numeroParciales()>0 && Parcial.getParcialEstricto(fecha)==parcialTrabajo) {
						labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	    			} else {
						labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	    			}
	    		}
			}
		}
		ponerDiasNoLectivos();
		actualizarDiasNoLectivosClase();
		ponerEventosCalendario();
		fechaHoyCalendario = null;
		fechaTrabajoCalendario = null;
		actualizarEtiquetaDiaHoyParcial();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");
	}
	public void actualizarParcial(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Update Partial ...");
		Calendar fecha=null;
		Calendar fFin=null;
		//System.out.println("Antinguo "+Fecha.formaFechaDiaHora(fInicioParcial)+"-"+Fecha.formaFechaDiaHora(fFinParcial));
		if (Parcial.numeroParciales()>0) {
			Calendar actualInicioParcial=Parcial.getFechaInicioParcial(Parcial.getParcial(Fecha.fechaDeTrabajo));
			Calendar actualFinParcial=Parcial.getFechaFinParcial(Parcial.getParcial(Fecha.fechaDeTrabajo));
			//System.out.println("Actual "+Fecha.formaFechaDiaHora(actualInicioParcial)+"-"+Fecha.formaFechaDiaHora(actualFinParcial));
			if (fInicioParcial==null)
				fecha=actualInicioParcial;
			else
				fecha=(fInicioParcial.compareTo(actualInicioParcial)<0)?(Calendar)fInicioParcial.clone():actualInicioParcial;
			if (fFinParcial==null)
				fFin=actualFinParcial;
			else
				fFin=(fFinParcial.compareTo(actualFinParcial)>0)?(Calendar)fFinParcial:actualFinParcial;
		} else {
			if (fInicioParcial!=null && fFinParcial!=null) {
				fecha=(Calendar)fInicioParcial.clone();
				fFin=(Calendar)fFinParcial.clone();
			}
		}
		//System.out.println("trabajo "+Fecha.formaFechaDiaHora(fecha)+"-"+Fecha.formaFechaDiaHora(fFin));
		if (fecha!=null && fFin!=null) {
			int indice=0;
			//System.out.println("Actualizar Parcial desde "+Fecha.formaFechaDia(fecha)+" hasta "+Fecha.formaFechaDia(fFin));
			for (;fecha.compareTo(fFin)<=0;fecha.add(Calendar.DAY_OF_MONTH,1)) {
				//System.out.println("For "+Fecha.formaFechaDiaHora(fecha)+"<="+Fecha.formaFechaDiaHora(fFin));
				if (!Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK)))
					if (!Fecha.diaNoLaboral(fecha,false))
						if (!Fecha.diaNoLaboral(fecha,true)) {
							boolean estaba=false;
							boolean esta=false;
							if (fInicioParcial!=null && fFinParcial!=null)
								if (fecha.compareTo(fInicioParcial)>=0 && fecha.compareTo(fFinParcial)<=0) estaba=true;
							if (Parcial.numeroParciales()>0)
								if (fecha.compareTo(Parcial.getFechaInicioParcial(Parcial.getParcial(Fecha.fechaDeTrabajo)))>=0
										&& fecha.compareTo(Parcial.getFechaFinParcial(Parcial.getParcial(Fecha.fechaDeTrabajo)))<=0) esta=true;
							//System.out.println("estaba ("+estaba+") esta ("+esta+") "+Fecha.formaFechaDia(fecha));
							if (estaba && !esta) {
								indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
								if (indice>=0) {
									Label etiqueta=etiquetas.get(indice);
									//System.out.println("blanco sobre negro, indice="+indice);
									//etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
									etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
								}
							} else if (!estaba && esta) {
								indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
								if (indice>=0) {
									Label etiqueta=etiquetas.get(indice);
									//System.out.println("negro sobre blanco, indice="+indice);
									//etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
									etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
								}
							}
						}
			}
		}
	}
	public void actualizarEtiquetaDiaHoyParcial(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		int indice=0;
		Label etiqueta=null;
		indice = fechas.indexOf(Fecha.formaFechaInt(fechaTrabajoCalendario));
		if (indice>=0) {
			etiqueta=etiquetas.get(indice);
			if (Fecha.diaLaboral(fechaTrabajoCalendario, true)) {
				if (fInicioParcial==null || fFinParcial==null || fechaTrabajoCalendario==null)
					etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
				else {
					if (fechaTrabajoCalendario.compareTo(fInicioParcial)>=0 && fechaTrabajoCalendario.compareTo(fFinParcial)<=0)
						etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
					else
						etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
				}
			} else
				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
		}
		indice = fechas.indexOf(Fecha.formaFechaInt(fechaHoyCalendario));
		if (indice>=0) {
			etiqueta=etiquetas.get(indice);
			if (Fecha.diaLaboral(fechaHoyCalendario, true))
				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
			else
				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
		}
		//System.out.println("Actualizando calendario parciales...");
		actualizarParcial();
		if (Parcial.numeroParciales()>0) {
			fInicioParcial=Parcial.getFechaInicioParcial(Parcial.getParcial(Fecha.fechaDeTrabajo));
			fFinParcial=Parcial.getFechaFinParcial(Parcial.getParcial(Fecha.fechaDeTrabajo));
		} else {
			fInicioParcial=null;
			fFinParcial=null;
    	}
		fechaHoyCalendario=Fecha.fechaHoraCero(Calendar.getInstance());
		indice=fechas.indexOf(Fecha.formaFechaInt(fechaHoyCalendario));
		if (indice>=0){
			etiqueta=etiquetas.get(indice);
			//System.out.println("Poniendo amarilla la etiqueta "+indice);
			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_YELLOW));
		}
		fechaTrabajoCalendario=Fecha.fechaDeTrabajo;
		indice=fechas.indexOf(Fecha.formaFechaInt(fechaTrabajoCalendario));
		if (indice>=0) {
			etiqueta=etiquetas.get(indice);
			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_RED));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() hoy "+Fecha.formaFecha(fechaHoyCalendario)+" trabajo "+Fecha.formaFecha(fechaTrabajoCalendario),true);
	}
	public void actualizarEtiquetaDia(Calendar fecha){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFecha(fechaHoyCalendario)+")");
		Vector<Vector<String>> eventos;
		fecha=Fecha.fechaHoraCero(fecha);
		int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
		if (indice>=0) {
			Label etiqueta=etiquetas.get(indice);
			etiqueta.setToolTipText("");
			if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
				//etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
			} else {
	   			boolean lectivo=true;
				Vector<Vector<String>> diaNoLectivo=PCuaderno.MiPCuaderno.bbdd.consultarDiaNoLectivo(fecha);
				//System.out.println("Calendario actualizarEtiquetaDia Descripcion noLectivo ("+diaNoLectivo.get(0).get(3)+") ...");
		   		if (diaNoLectivo!=null) if (diaNoLectivo.size()>0){
		   			String claseNoLectivo=null;
		   			String clase=null;
		   			String emergente="";
		   			for (int i=0;i<diaNoLectivo.size();i++){
			   			if (diaNoLectivo.get(i).get(1)==null){
			   				claseNoLectivo="NULL";
			   			} else {
			   				claseNoLectivo=diaNoLectivo.get(i).get(1);
			   				clase=MateriaClase.formaClase(MateriaClase.getIdClaseDeTrabajo());
			   			}
			   			if (claseNoLectivo.equals("NULL") || claseNoLectivo.equals(MateriaClase.getIdClaseDeTrabajo())) {
							//etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
				   			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
				   			if (emergente.equals("")) emergente="El dia "+Fecha.formaFechaDia(fecha)+":";
			   				emergente+="\n"+PCuaderno.MiPCuaderno.mensajes.getString("NoInstructionalDay")+": "+((clase!=null)?"("+clase+") ":"")+diaNoLectivo.get(i).get(5);
			   				lectivo=false;
			   			}
		   			}
		   			if (!emergente.equals("")) etiqueta.setToolTipText(emergente);
		   		}
		   		if (lectivo){
		   			int parcialTrabajo=Parcial.getParcial(Fecha.fechaDeTrabajo);
	    			if (parcialTrabajo>=0 && Parcial.getParcialEstricto(fecha)==parcialTrabajo) {
	    				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	    			} else {
	    				etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	    			}
		    	}
		   		etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			}
			idsEvento.set(indice,"");
			eventos=PCuaderno.MiPCuaderno.bbdd.consultarEventosTipoDia(null,fecha);
			for (int i=0;i<eventos.size();i++){
				actualizarEvento(eventos.get(i));
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFecha(fechaHoyCalendario)+") fin");
	}
	public void ponerEventosCalendario(){ //Dejar de utilizar
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> eventos;
		eventos=PCuaderno.MiPCuaderno.bbdd.consultarEventosTipoDesdeFecha(null,Fecha.inicioCurso);
		for (int i=0;i<eventos.size();i++){
			//System.out.println("Calendario ponerEventosCalendario Dia evento: "+eventos.get(i).get(0)+" info="+eventos.get(i).get(9));
			actualizarEvento(eventos.get(i));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end",true);
	}
	public void actualizarEvento(Vector<String> evento){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		//PCuaderno.MiPCuaderno.bbdd.imprimirRegistro(evento);
		//El color y evento click será del primer evento del día
		Vector<Vector<String>> eventoTipo;
		Calendar fecha = Fecha.fecha(evento.get(1),evento.get(2),evento.get(3));
		int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
		if (indice>=0) {
			Label etiqueta=etiquetas.get(indice);
			//System.out.println("Calendario actualizarEvento Actualizando evento en Calendario (id "+evento.get(0)+", "+Fecha.formaFecha(fecha)+")...");
			if (etiqueta!=null) {
				if (idsEvento.get(indice).equals("")) {
					final String idEvento=evento.get(0);
					idsEvento.set(indice, idEvento);
					//System.out.println("Calendario actualizarEvento Actualizando etiqueta ("+indice+") id="+idEvento);
					etiqueta.setForeground(Display.getCurrent().getSystemColor(Integer.parseInt(evento.get(11))));
				}
				String info="+ "+PCuaderno.MiPCuaderno.mensajes.getString("Calendario_LabelToolTips_info1")+" "+Fecha.formaHora(evento.get(4),evento.get(5));
				eventoTipo=PCuaderno.MiPCuaderno.bbdd.consultarEventoTipoDatos(evento.get(0),Integer.parseInt(evento.get(9)));
				//PCuaderno.MiPCuaderno.bbdd.imprimir(eventoTipo);
				if (eventoTipo!=null) if (eventoTipo.size()>0) {
					switch (Integer.parseInt(evento.get(9))) {
						case BBDD.idTipoEvaluacion:
							info+=" "+evento.get(10)+" "+eventoTipo.get(0).get(3)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+eventoTipo.get(0).get(4)+" "+eventoTipo.get(0).get(5);
							break;
						case BBDD.idTipoClaustro:
							info+=" "+evento.get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.expOrdinario:BBDD.expExtraordinario);
							break;
						case BBDD.idTipoConsejoEscolar: 
							info+=" "+evento.get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.expOrdinario:BBDD.expExtraordinario);
							break;
						case BBDD.idTipoETCP:
							info+=" "+evento.get(10);
							break;
						case BBDD.idTipoCitaConTutores:
							info+=" "+evento.get(10)+" ("+eventoTipo.get(0).get(1)+"):";
							Vector<Vector<String>> estudiantes = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesCitaTutores(evento.get(0));
							for (int j=0;j<estudiantes.size();j++){
								info+="\n  -"+estudiantes.get(j).get(2)+", "+estudiantes.get(j).get(1);
							}
							break;
						case BBDD.idTipoOtroTipo:
							info+=" "+evento.get(10);
							break;
					}
				} else {
					info+=" wihtout type asosiated (Error)";
				}
				if (etiqueta.getToolTipText()==null) {
					etiqueta.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Day")+" "+Fecha.formaFechaDia(Fecha.fecha(evento.get(1),evento.get(2),evento.get(3)))+":\n"+info);
				} else if (etiqueta.getToolTipText().equals("")){
					etiqueta.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Day")+" "+Fecha.formaFechaDia(Fecha.fecha(evento.get(1),evento.get(2),evento.get(3)))+":\n"+info);
				} else etiqueta.setToolTipText(etiqueta.getToolTipText()+"\n"+info);
			}
			if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");
		}
	}
	public void ponerDiasNoLectivos(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> dias;
		Label etiquetaDia;
		dias=PCuaderno.MiPCuaderno.bbdd.consultarDiasNoLectivosDiaCompletoYClase(null);
		for (int i=0;i<dias.size();i++){
			//System.out.print("Calendario ponerDiasNoLectivos Dia: "+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+" = "+dias.get(i).get(5)+".");
			int indice=fechas.indexOf(Fecha.formaFechaInt(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))));
			if (indice>=0) {
				etiquetaDia=etiquetas.get(indice);
				if (etiquetaDia!=null) {
					etiquetaDia.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
					etiquetaDia.setToolTipText("El dia "+Fecha.formaFechaDia(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4)))+":\n"+PCuaderno.MiPCuaderno.mensajes.getString("NoInstructionalDay")+": "+dias.get(i).get(5));
					//System.out.println("ok");
				} else PCuaderno.MiPCuaderno.notificar("Null label ("+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+")");
			} else {
				PCuaderno.MiPCuaderno.notificar("Date no found in calendar of current academic course ("+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+")");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end",true);
	}
	public void actualizarDiasNoLectivosClase(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> dias;
		Label etiquetaDia;
		dias=PCuaderno.MiPCuaderno.bbdd.consultarDiasNoLectivosClase(null);
		for (int i=0;i<dias.size();i++){
			//System.out.print("Calendario actualizarDiasNoLectivosClase Dia noLectivo Clase: "+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+" = "+dias.get(i).get(5)+".");
			int indice=fechas.indexOf(Fecha.formaFechaInt(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))));
			if (indice>=0) {
				etiquetaDia=etiquetas.get(indice);
				if (etiquetaDia!=null) {
					Calendar fecha=Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4));
					actualizarEtiquetaDia(fecha);
					//System.out.println("ok");
				} else PCuaderno.MiPCuaderno.notificar("Null label ("+Fecha.formaFecha(dias.get(i).get(1),dias.get(i).get(2),dias.get(i).get(3))+")");
			} else {
				PCuaderno.MiPCuaderno.notificar("Date no found in calendar of current academic course ("+Fecha.formaFecha(dias.get(i).get(1),dias.get(i).get(2),dias.get(i).get(3))+")");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end",true);
	}
}
