import java.util.Calendar;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class Configuracion extends Dialog {

	protected Object result;
	protected Shell shlConfiguracion;
	private ComboConId comboConIdInicio;
	private Combo comboDuracion;
	private Combo comboAgnoInicioCurso;
	public Configuracion(Shell parent) {
		super(parent,  SWT.TITLE | SWT.BORDER | SWT.APPLICATION_MODAL);
	}
	public Object open() {
		createContents();
		shlConfiguracion.open();
		shlConfiguracion.layout();
		Display display = getParent().getDisplay();
		while (!shlConfiguracion.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}
	private void createContents() {
		shlConfiguracion = new Shell(getParent(), getStyle());
		shlConfiguracion.setSize(460, 175);
		shlConfiguracion.setText(PCuaderno.MiPCuaderno.titulo+" - "+PCuaderno.MiPCuaderno.mensajes.getString("Configuracion_Shell_Text"));
		shlConfiguracion.setLayout(new GridLayout(2, false));
		Label lblMesDeIncio = new Label(shlConfiguracion, SWT.NONE);
		lblMesDeIncio.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblMesDeIncio.setText(PCuaderno.MiPCuaderno.mensajes.getString("Configuracion_LblMesDeInicio_Text"));
		Combo comboInicio = new Combo(shlConfiguracion,SWT.READ_ONLY);
		comboInicio.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		comboConIdInicio = new ComboConId(comboInicio);
		Calendar fecha = Calendar.getInstance();
		fecha.set(Calendar.DAY_OF_MONTH,1);
		fecha.set(Calendar.MONTH, Calendar.JANUARY);
		for (int x=1;x<=12;x++) {
			comboConIdInicio.addElemento(String.valueOf(fecha.get(Calendar.MONTH)), Fecha.mesLargo(fecha));
			fecha.add(Calendar.MONTH, +1);
		}
		comboConIdInicio.seleccionarId(String.valueOf(Fecha.MesInicioCurso));
		Label lblDuracionDelCurso = new Label(shlConfiguracion, SWT.NONE);
		lblDuracionDelCurso.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDuracionDelCurso.setText(PCuaderno.MiPCuaderno.mensajes.getString("Configuracion_LblDuracionDelCurso_Text"));
		comboDuracion = new Combo(shlConfiguracion,SWT.READ_ONLY);
		for (int x=1;x<=24;x++) comboDuracion.add(String.valueOf(x));
		comboDuracion.select(Fecha.MesesLectivosCurso-1);
		comboDuracion.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblAgnoInicioCurso = new Label(shlConfiguracion, SWT.NONE);
		lblAgnoInicioCurso.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblAgnoInicioCurso.setText(PCuaderno.MiPCuaderno.mensajes.getString("Configuracion_LblAgnoInicioCurso_Text"));
		
		comboAgnoInicioCurso = new Combo(shlConfiguracion,SWT.READ_ONLY);
		comboAgnoInicioCurso.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		for (int x=2011;x<=2050;x++) comboAgnoInicioCurso.add(String.valueOf(x));
		Calendar fechaHoy=Calendar.getInstance();
		int mesHoy = fechaHoy.get(Calendar.MONTH);
		int agnoHoy = fechaHoy.get(Calendar.YEAR);
		fechaHoy.set(Calendar.MONTH, Fecha.MesInicioCurso);
		fechaHoy.add(Calendar.MONTH, Fecha.MesesLectivosCurso);
		int mesFinDef = fechaHoy.get(Calendar.MONTH);
		fechaHoy=Calendar.getInstance();
		fechaHoy.set(Calendar.MONTH, mesFinDef);
		fechaHoy.add(Calendar.MONTH, -Fecha.MesesLectivosCurso);
		int agnoIni = fechaHoy.get(Calendar.YEAR);
		comboAgnoInicioCurso.select(((mesHoy<mesFinDef)?agnoIni:agnoHoy)-2011);
		
		Button btnAceptar = new Button(shlConfiguracion, SWT.NONE);
		btnAceptar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Fecha.MesInicioCurso=Integer.valueOf(comboConIdInicio.idSeleccionado());
				Fecha.MesesLectivosCurso=comboDuracion.getSelectionIndex()+1;
				Fecha.AgnoInicioCurso=Integer.parseInt(comboAgnoInicioCurso.getItem(comboAgnoInicioCurso.getSelectionIndex()));
				shlConfiguracion.dispose();
			}
		});
		btnAceptar.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
		btnAceptar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Ok"));
	}
}
